import { Controller, Get, Request } from '@nestjs/common';
import { UserInfoResponse } from 'picsur-shared/dist/dto/api/user-manage.dto';
import { Permission } from 'picsur-shared/dist/dto/permissions.enum';
import { RequiredPermissions } from '../../../decorators/permissions.decorator';
import { Returns } from '../../../decorators/returns.decorator';
import type AuthFasityRequest from '../../../models/interfaces/authrequest.dto';

@Controller('api/experiment')
@RequiredPermissions(Permission.SysPrefAdmin)
export class ExperimentController {
  constructor() {}

  @Get()
  @Returns(UserInfoResponse)
  async testRoute(
    @Request() req: AuthFasityRequest,
  ): Promise<UserInfoResponse> {
    return req.user;
  }
}
